package com.yongqi.xinrenli.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.yongqi.xinrenli.domain.bo.DbUserFeedbackBo;
import com.yongqi.xinrenli.domain.vo.DbUserFeedbackVo;
import com.yongqi.xinrenli.domain.DbUserFeedback;
import com.yongqi.xinrenli.mapper.DbUserFeedbackMapper;
import com.yongqi.xinrenli.service.IDbUserFeedbackService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 用户反馈Service业务层处理
 *
 * @author zyf
 * @date 2023-03-09
 */
@RequiredArgsConstructor
@Service
public class DbUserFeedbackServiceImpl implements IDbUserFeedbackService {

    private final DbUserFeedbackMapper baseMapper;

    /**
     * 查询用户反馈
     */
    @Override
    public DbUserFeedbackVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询用户反馈列表
     */
    @Override
    public TableDataInfo<DbUserFeedbackVo> queryPageList(DbUserFeedbackBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<DbUserFeedback> lqw = buildQueryWrapper(bo);
        Page<DbUserFeedbackVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询用户反馈列表
     */
    @Override
    public List<DbUserFeedbackVo> queryList(DbUserFeedbackBo bo) {
        LambdaQueryWrapper<DbUserFeedback> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<DbUserFeedback> buildQueryWrapper(DbUserFeedbackBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<DbUserFeedback> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getUserId() != null, DbUserFeedback::getUserId, bo.getUserId());
        lqw.eq(StringUtils.isNotBlank(bo.getTitle()), DbUserFeedback::getTitle, bo.getTitle());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), DbUserFeedback::getContent, bo.getContent());
        lqw.eq(StringUtils.isNotBlank(bo.getCreateUser()), DbUserFeedback::getCreateUser, bo.getCreateUser());
        lqw.eq(StringUtils.isNotBlank(bo.getModifyUser()), DbUserFeedback::getModifyUser, bo.getModifyUser());
        lqw.eq(bo.getModifyTime() != null, DbUserFeedback::getModifyTime, bo.getModifyTime());
        lqw.eq(bo.getDeleteStatus() != null, DbUserFeedback::getDeleteStatus, bo.getDeleteStatus());
        return lqw;
    }

    /**
     * 新增用户反馈
     */
    @Override
    public Boolean insertByBo(DbUserFeedbackBo bo) {
        DbUserFeedback add = BeanUtil.toBean(bo, DbUserFeedback.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改用户反馈
     */
    @Override
    public Boolean updateByBo(DbUserFeedbackBo bo) {
        DbUserFeedback update = BeanUtil.toBean(bo, DbUserFeedback.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(DbUserFeedback entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除用户反馈
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
